# Copyright (C) 2003-2006 azurIt (azurit@pobox.sk, azurIt@IRCnet)

from random import uniform, randint
from copy import copy
from math import e as euler
from sys import exit

class neuron:
	def __init__(self, vstupy, alfa):
		self.vstupy = vstupy
		# vygenerujem si potrebne mnozstvo vah (pocet vstupov + 1)
		self.vahy = []
		for i in xrange(len(self.vstupy[0])):
			self.vahy.append(uniform(-1, 1))

		# rychlost ucenia, od 0 po 1
		self.alfa = alfa

		# threshold, je vzdy -1
		self.xt = -1

		# pocet zbehnutych epoch
		self.po_ep = 0


	def ucenie(self):
		self.po_ep += 1
		e = self.epocha()
		# ucim sa dokym to uz neviem :)
		while e > 0:
			self.po_ep += 1
			e = self.epocha()
		# vraciam cislo epochy, v ktorej bolo ucenie uspesne skoncene
		#print "naucene v epoche", self.po_ep
		return self.po_ep


	def epocha(self):
		#print "epocha", self.po_ep
		# prekopirujem si vstupy, aby som o ne neprisiel
		vstupy = copy(self.vstupy)
		e = 0
		print "epocha", self.po_ep
		while len(vstupy) != 0:
			# zoberiem nahodnu sadu vstupov z dostupnych
			p = randint(0, len(vstupy)-1)
			vst = vstupy[p]

			# vypocitam vystup
			y = self.output(vst)

			# vypocitam chybu
			et = self.error(vst[-1], y)
			e = e + et
			#print et
			if et > 0:
				# prestavujem vahy
				x = 0
				for i in vst[:-1]:
					self.vahy[x] = self.set_scales(self.vahy[x], vst[-1], y, i)
					x += 1
				self.vahy[-1] = self.set_scales(self.vahy[-1], vst[-1], y, self.xt)
			print vst[:-1], y, vst[-1], self.vahy
			# vymazem uz spracovanu sadu vstupov
			vstupy.pop(p)
		print "--------"
		return e


	def set_scales(self, wj, d, y, xj):
		# vzorec  Wj(t+1) = Wj(t) + (alfa * (d - y) * Xj)
		return wj + (self.alfa * (d - y) * xj)


	def output(self, vstupy):
		y = 0
		x = 0
		# vzorec  --- n+1
		#         \
		#         /        Wj * Xj
		#         --- j=1
		for i in vstupy[:-1]:
			y = y + (self.vahy[x] * i)
			x += 1
		y = y + (self.vahy[-1] * self.xt)

		# orezem y
		return self.mk_output(y)


	def mk_output(self, y):
		if y > 0:
			return 1
		else:
			return 0


	def error(self, d, y):
		# vzorec  1/2 * (d - y)^2
		return 0.5 * (d - y)**2


class c_neuron(neuron):
	def mk_output(self, y):
		# vzorec  1 / (1 + e^-y)
		return 1/(1 + (euler**(-y)))


	def set_scales(self, wj, d, y, xj):
		# vzorec  Wj(t+1) = Wj(t) + alfa * (d - y) * y * (1 - y) * Xj
		return wj + self.alfa * (d - y) * y * (1 - y) * xj


	def ucenie(self):
		self.po_ep += 1
		e = self.epocha()
		# ucim sa dokym to uz neviem :)
		while e > 0.3:
			#print self.po_ep, e
			self.po_ep += 1
			e = self.epocha()
		# vraciam cislo epochy, v ktorej bolo ucenie uspesne skoncene
		#print "naucene v epoche", self.po_ep
		return self.po_ep


# vstupy sa davaju vo forme dvojrozmerneho pola, v kazdom riadku jedna sada
# v ktorej posledny prvok je to, co ma byt na vystupe (d)

# OR
#vstupy = [
#[0, 0, 0],
#[0, 1, 1],
#[1, 0, 1],
#[1, 1, 1]
#]


# AND
vstupy = [
[0, 0, 0],
[0, 1, 0],
[1, 0, 0],
[1, 1, 1]
]


# vstupy zo suboru perceptron2.dat
"""file_obj = open("perceptron2.dat", "r")
lines = file_obj.readlines()
file_obj.close()

vstupy = []
temp = []
for i in lines:
	i = i.split()
	if len(i) == 1:
		temp.append(int(i[0]))
		vstupy.append(temp)
		temp = []
	else:
		for j in i:
			temp.append(int(j))


# toto tu je aby sa to cele spustilo iba raz
alfa = 0.5
neur = c_neuron(vstupy, alfa)
#neur = neuron(vstupy, alfa)
print neur.ucenie()
exit()"""

alfa = 0.5
poc_tes = 1
krok = 0.05
koniec = long(100000)
while alfa < koniec:
	priemer = 0
	for i in xrange(poc_tes):
		# spojity
		neur = neuron(vstupy, alfa)
		# diskretny
		#neur = neuron(vstupy, alfa)
		priemer += neur.ucenie()
	priemer = priemer/poc_tes
	print alfa, priemer
	alfa += krok
	break
